
#include "error.ch"


****
*       SYSERROR.PRG
*

#define OUT(str)                BUILDBUF( str )
#define OUTNL(str)              BUILDBUF( Chr(13) + Chr(10) + str )


***
*       SysError()
*

proc ErrorSys()
* get old handler block
ErrorBlock( {|e| MyError(e)} )
return


***
*       MyError()
*
static func MyError(e)
local i,x,y
local ver_no:='v2.0'
i:=1
while !empty(procname(i++))
  if procname(i)=='(b)ERRORSYS'
    i:=1
    while !empty(procname(i++))
      ? procname(i)
      i++
    enddo
    ?
    ? 'Error occured in Error Handler'
    ?
    wait
    close all
    commit
    quit
  endif
enddo
* clear buffer
buildbuf(.t.)

*if ( e:genCode == EG_OPEN .and. NetErr() .and. e:canDefault )
if ( e:genCode == EG_OPEN .and. e:oscode == 32 .and. e:canDefault )
  neterr(.t.)
  return (.f.)    /* ignore */
endif

OUTNL('A system error occured, contact your programmer')
OUTNL('')
/* put message to STDOUT */
if(e:severity > ES_WARNING, OUTNL( "Error" ), OUTNL("Warning"))

if ( valtype(e:subsystem)=='C')
  OUT( " " + e:subsystem + "[" + LTrim(Str(e:subCode())) + "]" )
endif

if ( valtype(e:description)='C' )
  OUT( "  " + e:description )
endif

if ( ! Empty(e:operation) )
  OUT( ": " + e:operation )
endif

if ( !Empty(e:filename))
  OUT( ": " + e:filename)
endif

if ( e:canRetry)
  OUTNL( "Could have retried")
else
  OUTNL( "Could NOT retry")
endif

i:=e:args
if (valtype(i) = 'A' )

  x:=len(i)
  if x=1
    OUTNL( "1 argument exists")
 else
    OUTNL( ALLTRIM(STR(X))+" arguments exist")
  endif

  for y:=1 to x
    OUTNL("Arg"+alltrim(str(y))+': Type = <'+;
    valtype(i[y])+'>   Value = <'+retstr(i[y])+'>')
  next y
else
  OUTNL('No arguments exist')
endif

if e:oscode>0
  OUTNL('DOS error was '+alltrim(str(e:oscode)))
endif

i := 2
while (.t.)
  OUTNL( "Called from " + Trim(ProcName(i)) + ;
         "(" + Alltrim(Str(ProcLine(i))) + ")  " )
  i++

  if ( ProcName(i) == "" )
    OUTNL('Errors trapped by SysError - '+ver_no+', Copyright (c) E. Mark Kothe')
    buildbuf(.f.)
    wait
    ERRORLEVEL(1)
    QUIT
  endif
enddo

return (.f.)

function buildbuf(str_passed)
static buffer
memvar getlist
if valtype(str_passed)=='L'
  if str_passed
    buffer=''
  else
    * 12/30/90 added reporting of screens to file
    * look thru call stack to end
    * last element is our starting procedure name
*    i:=1
*    while !empty(procname(i++))
*    enddo
    * gotta subtract 2 to get to last valid name
    * example element 3 is valid, 4 will test empty, but
    * i++ will increment 1 further after finding blank
*    erept(scr2var(), procname(i-2)+'.scr')
    clear
    ? buffer
    erept(buffer)
  endif
else
  buffer+=str_passed
endif
return(.t.)

function retstr(oldstr)
*returns a string from whatever it was sent
DO CASE
  CASE valtype(oldstr)='C'
    RETURN(oldstr)
  CASE valtype(oldstr)='N'
    RETURN(STR(oldstr))
  CASE valtype(oldstr)='D'
    RETURN(DTOC(oldstr))
  CASE valtype(oldstr)='L'
    IF oldstr
      RETURN(".T.")
    ELSE
      RETURN(".F.")
    ENDIF
  CASE valtype(oldstr)='M'
    RETURN("(memo field)")
  CASE valtype(oldstr)='A'
    RETURN("(array)")
  OTHERWISE
   RETURN("Undefined")
ENDCASE
RETURN(.T.)
